//eine farbe wird gewählt, alle lampen nehmen eine farbe in der nähe dieser Farbe an und faden in Helligkeit wie auch im farbton
//vorgabe: h und v, s ist immer zwischen 80 und 100




//#define colordeviation 30
#define MAXSDEVIATION 120
#define MAXVDEVIATION 40

void setsimilarcolor(byte h, byte s, byte v, unsigned char lamp) //sets endbuffer of "lamp" to similar color than the given one
{


  hsvbuffer[0][lamp] = h + colordeviation/2 - random(colordeviation);
  hsvbuffer[1][lamp] = s  - random(MAXSDEVIATION);//constrain(s + MAXSDEVIATION/2 - random(MAXSDEVIATION), 253, 255);
  hsvbuffer[2][lamp] = v  - random(MAXVDEVIATION);

  // Serial.println( hsvbuffer[2][lamp],DEC);
  // if(hsvbuffer[1][lamp] < (s-MAXSDEVIATION)) hsvbuffer[1][lamp] =255;

  hsv_to_rgb ( hsvbuffer[0][lamp],  hsvbuffer[1][lamp],  hsvbuffer[2][lamp], lamp);     

}




//start - level*((start-end)/max)


//when called, sets similar colors and fades in steps, the more steps, the slower
#define MAXBLENDSTEPS 200
#define MINBLENDSTEPS 70
/*
takes the color in the globalHSV buffer, selects a similar color for all lamps and
 fades to that color in randmo speed for each lamp.
 to change the color, set the global HSV buffer
 
 */
void similarcolors(void) 
{
  static unsigned int blendstep[6]; 
  static unsigned int maxblendstep[6];

  for(int l = 0; l<6; l++) //get new color for all lamps
  {
    blendstep[l]++;
    blend(blendstep[l], maxblendstep[l], l);     
    if(blendstep[l] >= maxblendstep[l]) //end of blend reached, select new color to fade to  
    {
      blendstep[l] = 0;
      copycolorbuffer(l); //copy endbuffer to startbuffer


      if(randomizecolorchange)
      {
        //note the "chosenone" change code is not working like it should
        //uncomment the fallowing lines if you want to test it...
        
        /*
        //check if buffer needs to be switched:
        if((changed & (1<<l)) == 0) //if lamp has not yet switched the buffer
        {
          if(l == 0) //for lamp 0, only lamp 1 needs to be checked
          {
            if(changed & (1<<1))  
            {
              usebuffer[0] = usebuffer[1];
            }
          }
          else if(l == 5) //for lamp 5, only lamp 4 needs to be checked
          {
            if(changed & (1<<4)) usebuffer[5] = usebuffer[4];
          }
          else
          {
            if(changed & (1<<(l-1)))
            {
              usebuffer[l] = usebuffer[l-1];
            }
            if(changed & (1<<(l+1)))
            {
              usebuffer[l] = usebuffer[l+1];
            }

          }
          changed |= (1<<l);
        }
      }
      else
      {
      
      */
        
        for(byte i = 0; i<6; i++)
        {
          usebuffer[i] = 0; //all lamps use buffer 0
        }

        
      }
      
      

      if(usebuffer[l]) //which buffer is the active one?
      {
        setsimilarcolor(globalHSV2[0], globalHSV2[1], globalHSV2[2],l);
      }
      else
      {
        setsimilarcolor(globalHSV[0], globalHSV[1], globalHSV[2],l);
      }


      //now get new values for blending speed  
      maxblendstep[l] = random(MINBLENDSTEPS, MAXBLENDSTEPS);

    }
  }

}












