
void updatelamp(byte lamp)
{
 // Serial.print("updating lamp ");
 // Serial.println(lamp,DEC);
  TWIwatchdog = 0;
  if(lamp>5) lamp = 5;
  if(lamp==0)
  {
    //update pwm of master
    //    OCR1A =  color[RED][0];
    //    OCR1B = color[GREEN][0];
    //    OCR2A = color[BLUE][0];

    setsoftpwm();

  }
  else
  {
    byte answer = 0;
    // byte sendstatus = 1;
    byte checksum = 0;
    byte retries = 0;

    int sendstatus = -1;
    int sendtimeout = 0;

    while(sendstatus != 0)
    {
      sendstatus = sendcolors(lamp);
     // Serial.println(sendstatus,HEX);
#ifdef TWIDEBUG
      if(sendstatus){
        sendfailed++;
       // delay(10);
       // Serial.print("send to lamp ");
       // Serial.print(lamp,DEC);
       // Serial.println(" failed");
      }
#endif
      sendtimeout++;
      if(sendtimeout > 5) break;

    }
#ifdef TWIDEBUG
      if(sendstatus == 0){
    sendsuccessful++;
   // delay(10);
   // Serial.print("send to lamp ");
   // Serial.print(lamp);
   // Serial.println(" successful");
      }
#endif
  }

}



void switchofflamp(byte lamp)
{
  color[RED][lamp]=0;
  color[GREEN][lamp]=0;
  color[BLUE][lamp]=0;
  updatelamp(lamp);
  updatelamp(lamp); //send zero 2 times
}


void setlamp(byte lamp, byte red, byte green, byte blue)
{
  color[RED][lamp] = red;
  color[GREEN][lamp] = green;
  color[BLUE][lamp] = blue;
  updatelamp(lamp);  
}

void setalllamps(byte red, byte green, byte blue)
{
  for(int i = 0; i < 5; i++) //set all colors of all lamps
  {
    color[RED][i] = red;
    color[GREEN][i] = green;
    color[BLUE][i] = blue;
  }
  updatealllamps();
}

void updatealllamps(void)
{
//  updatelamp(5);
//  updatelamp(4);
//  updatelamp(3);
//  updatelamp(2);
//  updatelamp(1);
//  updatelamp(0);

}





void alloff(void)
{
  //  for(int i = 0; i<5; i++) //off command needs to be sent 4 times in a row to work
  //  {
  setalllamps(0,0,0);

  //  }

}



uint16_t calc_CRC16(byte lampnumber) //check crc from received data

{
  uint16_t crc = 0xffff; //initial value must be ffff!
  for(uint8_t i = 0; i<3 ; i++)
  {
    crc = _crc16_update(crc, color[i][lampnumber]);
  }
  return crc;
}


void wait(void) //delay for 1us @ 16MHz
{
  asm volatile ("nop");
  asm volatile ("nop");
  asm volatile ("nop");
  asm volatile ("nop");
  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
//  asm volatile ("nop");
}



// 0° = Rot, 120° = Grün, 240° = Blau
// void hsv_to_rgb (unsigned char h, unsigned char s, unsigned char v, unsigned char lamp)
// {
//
//
//byte r = byte((sin((float)h*(PI/127.5)+PI/2)+1)/2*v);
//byte g = byte((sin((float)h*(PI/127.5)+1.1666666*PI)+1)/2*v);
//byte b = byte((sin((float)h*(PI/127.5)+1.83333333*PI)+1)/2*v);
//
//Serial.println(r,DEC);
// //set new endbuffer
// colorbuffer[0][lamp][1] = r;
// colorbuffer[1][lamp][1] = g;
// colorbuffer[2][lamp][1] = b;
// }
// 
// 


////hsv to rgb with floats (more accurate) H,S and V range from 0 to 255
void hsv_to_rgb(float H, unsigned char S, unsigned char V, unsigned char lamp)	
{
  float s=(float)S/255.0; //auf 1 normieren
  float v=(float)V/255.0; //auf 1 normieren
  float r,g,b;			
  int i;
  float f, p, q, t;
  if( s == 0 ) 
  {
    r = g = b = v;
    return;
  }


  i = (int)(H/42.5) %6;
  f = H/42.5 - (int)(H/42.5);		
  p = v * ( 1.0 - s );
  q = v * ( 1.0 - (s * f));
  t = v * ( 1.0 - (s * ( 1.0 - f )));


  switch( i )
  {
  case 0:
    r = v; 
    g = t; 
    b = p;
     Serial.println(v); 
    Serial.println(t); 
    Serial.println(p); 
    break;

  case 1:
    r = q; 
    g = v; 
    b = p; 
    break;

  case 2:
    r = p; 
    g = v; 
    b = t; 
      Serial.println(v); 
    Serial.println(t); 
    Serial.println(p);
    break;
    
  case 3:
    r = p; 
    g = q; 
    b = v; 
    break;			
    
  case 4:
    r = t; 
    g = p; 
    b = v; 
      Serial.println(v); 
    Serial.println(t); 
    Serial.println(p);
    break;
    
  default:								
    r = v; 
    g = p; 
    b = q; 
    break;				// case 5:					

  }

  //set new endbuffer
  colorbuffer[0][lamp][1] = byte(round(r*255));
  colorbuffer[1][lamp][1] = byte(round(g*255));
  colorbuffer[2][lamp][1] = byte(round(b*255));


}

//hsv to rgb with int
//void hsv_to_rgb (unsigned char h, unsigned char s, unsigned char v, unsigned char lamp)
//{
//  unsigned char r,g,b, i, f;
//  unsigned int p, q, t;
//
//  if( s == 0 ) 
//  {  
//    r = g = b = v;
//  }
//  else
//  {  
//    i=h/43;
//    f=h%43;
//    p = (v * (255 - s))/256;
//    q = (v * ((10710 - (s * f))/42))/256;
//    t = (v * ((10710 - (s * (42 - f)))/42))/256;
//
//    switch( i )
//    {  
//    case 0:
//      r = v; 
//      g = t; 
//      b = p; 
//      break;
//    case 1:
//      r = q; 
//      g = v; 
//      b = p; 
//      break;
//    case 2:
//      r = p; 
//      g = v; 
//      b = t; 
//      break;
//    case 3:
//      r = p; 
//      g = q; 
//      b = v; 
//      break;      
//    case 4:
//      r = t; 
//      g = p; 
//      b = v; 
//      break;        
//    case 5:
//      r = v; 
//      g = p; 
//      b = q; 
//      break;
//    }
//  }
//  //set new endbuffer
//  colorbuffer[0][lamp][1] = r;
//  colorbuffer[1][lamp][1] = g;
//  colorbuffer[2][lamp][1] = b;
//}




void toggleLED()
{
  static uint8_t togglestate = 0;

  togglestate = ~togglestate; //toggle status
  if(togglestate) digitalWrite(13,HIGH);
  else digitalWrite(13,LOW);
}

void copycolorbuffer(byte l)
{
  colorbuffer[0][l][0] = colorbuffer[0][l][1]; //endbuffer = new startbuffer  
  colorbuffer[1][l][0] = colorbuffer[1][l][1]; //endbuffer = new startbuffer  
  colorbuffer[2][l][0] = colorbuffer[2][l][1]; //endbuffer = new startbuffer  
}
void setcolorbuffertocurrent(byte l) //sets startbuffer to current color
{
  colorbuffer[0][l][0] =  color[0][l];
  colorbuffer[1][l][0] =  color[1][l];  
  colorbuffer[2][l][0] =  color[2][l];   
}
void setcurrenttocolorbuffer(byte l) //sets current color to endbuffer
{
  color[0][l] = colorbuffer[0][l][1];
  color[1][l] = colorbuffer[1][l][1];
  color[2][l] = colorbuffer[2][l][1];
}

void copytosecondaryHSV(void) //copy primary hsv buffer of all lamps to secondary buffer
{
  for(byte i = 0; i<3; i++)
  {
    for(byte j = 0; j<6; j++)
    {
      secondaryhsvbuffer[i][j] = hsvbuffer[i][j];
    }  
  }
}

void copyfromsecondaryHSV(void) //copy secondary hsv buffer of all lamps to primary buffer
{
  for(int i = 0; i<3; i++)
  {
    for(int j = 0; j<6; j++)
    {
      hsvbuffer[i][j] = secondaryhsvbuffer[i][j];
    }  
  }

}


void writehsvbufferstoeeprom(byte dataset) //stores eachs lamp hsv buffer in eeprom, dataset is dataset position to use (0...28 for 512bytes of eeprom) 
{
  for(int i=0; i<6;i++) //do all 6 lamps
  {
    EEPROM.write(((i+(dataset*6))*3),  hsvbuffer[0][i]);
    EEPROM.write(((i+(dataset*6))*3)+1,  hsvbuffer[1][i]);
    EEPROM.write(((i+(dataset*6))*3)+2,  hsvbuffer[2][i]);
    Serial.print("data written to ");
    Serial.println(((i+(dataset*6))*3),DEC);
  }


}

void readhsvbuffersfromeeprom(byte dataset) //reads stored dataset from eeprom
{
  for(int i=0; i<6;i++) //do all 6 lamps
  {
    hsvbuffer[0][i] = EEPROM.read(((i+(dataset*6))*3));
    hsvbuffer[1][i] = EEPROM.read(((i+(dataset*6))*3)+1);
    hsvbuffer[2][i] = EEPROM.read(((i+(dataset*6))*3)+2);
    Serial.print("data read from ");
    Serial.println(((i+(dataset*6))*3),DEC);
  }

}

void SaveCurrentModeToEeprom(void)
{
  //die letzten 8 bytes sind reserviert für resume funktion, das letzte beinhaltet jeweils den mode

  EEPROM.write(511, mode); //save current mode to last byte

    switch(mode)
  { 
  case 0://change color of all lamps
    //save global HSV H value, S and V are always 255 (off is not saved)

    EEPROM.write(510,   globalHSV[0]);


    break;

  case 1: //similar color mode, increase color spread
    //save global HSV H value and deviation , mode
    EEPROM.write(510,   globalHSV[0]);

    break;

  case 2: //rainbow 
    //save rainbowstretch, current key and mode
    break;

  case 3: //programming and preset mode 
    //save preset number

    EEPROM.write(510,   presetkeyno);

    break;


  } 
}

void RestoreCurrentModeFromEeprom(void)
{
  mode = EEPROM.read(511);
  Serial.println("mode read from eeprom");
  switch(mode)
  { 
  case 0://change color of all lamps
    globalHSV[0] = EEPROM.read(510);
    globalHSV[1] = 255;
    globalHSV[2] = 255;

    break;

  case 1: //similar color mode, increase color spread
    //get key number, colordeviation, mode (not done yet)

    break;

  case 2: //rainbow and other fade mode
    //get rainbowstretch, current key and mode
    rainbowstretch=6;
    initrainbow(rainbowstretch); 
    break;

  case 3: //programming and preset mode 
    //load preset colors from stored preset number
    readhsvbuffersfromeeprom(EEPROM.read(510));
    break;


  } 
}


void setlamptoHSV(byte H, byte S, byte V, byte lamp) //set selected lamp to HSV values
{
  hsv_to_rgb(H, S, V, lamp); //sets endbuffer to lamp HSV
  setcurrenttocolorbuffer(lamp); //set current color to endbuffer 

}







